<template>
  <v-col>
    <v-col class="mb-2">
      <v-row align="end">
        <v-btn v-if="$vuetify.breakpoint.smAndUp && !seleccionable" class="mr-2" color="accent" @click="abrirForm">
          <v-icon left>
            fal fa-user-plus
          </v-icon>
          Nuevo proveedor
        </v-btn>
        <v-btn :block="$vuetify.breakpoint.smAndDown" color="seconday" @click="descargarLista">
          Descargar proveedores
        </v-btn>
        <v-spacer v-if="$vuetify.breakpoint.smAndUp" />
        <v-text-field
          v-model="search"
          append-icon="fal fa-search"
          label="Buscar"
          single-line
          color="accent"
          hide-details
          :style="$vuetify.breakpoint.smAndDown ? 'display: block' : 'max-width: 40vh'"
        />
      </v-row>
    </v-col>
    <v-data-table
      ref="tabla"
      v-model="selected"
      :items-per-page="10"
      :headers="seleccionable ? headersSeleccionable : headers"
      :items="proveedores"
      :search="search"
      class="elevation-1"
      item-key="idproveedores"
      :show-select="seleccionable"
      single-select
      @item-selected="enviarSeleccionado()"
    >
      <template v-if="!seleccionable" #[`item.action`]="{ item }">
        <v-icon
          small
          class="mr-2 fal fa-edit"
          @click="modificarProveedor(item)"
        />
        <v-icon
          small
          class="fal fa-trash-alt"
          @click="eliminarProveedor(item.idproveedores)"
        />
      </template>
    </v-data-table>
    <up-web-view v-if="showDialogPDF" :url="urlPDF" @onClose="showDialogPDF=false" />
  </v-col>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue } from 'vue-property-decorator'
import AppToast from '~/core/utils/AppToast'
import { Proveedor } from '~/core/models/proveedor'
import { ProveedoresStore } from '~/store/ProveedoresStore'
import { AppStore } from '~/store/AppStore'
import { App } from '~/core/App'
import UpWebView from '~/components/shared/UpWebView.vue'
    @Component({
      components: { UpWebView }
    })
export default class listaClientes extends Vue {
        @Ref() tabla;
        @Prop({ default: false }) seleccionable!:boolean;
      @Prop({ default: null }) proveedorSeleccionado!:Proveedor;

      search = '';
      selected:Proveedor[] = [];
      showDialogPDF:boolean = false;
      urlPDF:string = '';

      headersSeleccionable = [
        { text: 'Seleccione', align: 'left', value: 'data-table-select' },
        { text: 'ID', align: 'left', value: 'idproveedores' },
        { text: 'Nombre', align: 'left', value: 'nombre' },
        { text: 'DNI', align: 'left', value: 'dni' },
        { text: 'Teléfono', align: 'left', value: 'telefono' },
        { text: 'Ciudad', align: 'left', value: 'ciudad' },
        { text: 'Dirección', align: 'left', value: 'direccion' },
        { text: 'E-mail', align: 'left', value: 'email' },
        { text: 'Página web', align: 'left', value: 'web' },
        { value: 'icons', align: 'right', sortable: false, width: 80 }

      ];

        headers = [
          { text: 'ID', align: 'left', value: 'idproveedores' },
          { text: 'Nombre', align: 'left', value: 'nombre' },
          { text: 'DNI', align: 'left', value: 'dni' },
          { text: 'Teléfono', align: 'left', value: 'telefono' },
          { text: 'Ciudad', align: 'left', value: 'ciudad' },
          { text: 'Dirección', align: 'left', value: 'direccion' },
          { text: 'E-mail', align: 'left', value: 'email' },
          { text: 'Página web', align: 'left', value: 'web' },
          { value: 'action', align: 'right', sortable: false }
        ];

        get proveedores ():Proveedor[] {
          return ProveedoresStore.listaProveedores
        }

        mounted () {
          if (this.proveedorSeleccionado === null) {
            this.selected = []
          } else { this.selected.push(this.proveedorSeleccionado) }
        }

        modificarProveedor (val) {
          this.$emit('onEdit', val)
        }

        eliminarProveedor (id:number) {
          this.$confirm('¿Está seguro?').then(async (res) => {
            if (res) {
              await ProveedoresStore.eliminarProveedor(id)
              AppToast.info('Proveedor eliminado')
            }
          }).catch()
        }

        enviarSeleccionado () {
          setTimeout(() => {
            this.$emit('selectedProveedor', this.selected[0])
          }, 300)
        }

        abrirForm () {
          this.$emit('onAbrir')
        }

        descargarLista () {
          AppStore.SHOW_LOADING('Descargando datos...')
          const url = 'comprobantes/proveedores'
          App.$axios.get(url, {
            headers: { Accept: 'application/json' },
            responseType: 'blob'
          }).then((res) => {
            const data: Blob = res.data
            this.urlPDF = window.URL.createObjectURL(data)
            this.showDialogPDF = true
          }).catch(() => {
            AppToast.error('Hubo un error al descargar los datos para imprimir')
          }).finally(() => {
            AppStore.HIDE_LOADING()
          })
        }
}
</script>

<style lang="scss">
</style>
